#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue May 16 07:53:17 2017

@author: thiago
"""

class NoDeque():
    def __init__(self, x, proximo = None, prev = None):
        self.dado = x
        self.proximo = proximo
        self.prev = prev
        if proximo != None:
            self.proximo.prev = self
        if prev != None:
            self.prev.proximo = self
        
    def desliga(self):
        if self.proximo!=None:
            self.proximo.prev = self.prev
        if self.prev!=None:
            self.prev.proximo = self.proximo
        self.proximo = None
        self.prev = None
    
    def __iter__(self):
        a = self
        while a!=None:
            yield a.dado
            a = a.proximo
        

class NoLL():
    def __init__(self, x, proximo=None):
        self.dado = x
        self.proximo = proximo
    
    def __iter__(self):
        a = self
        while a!=None:
            yield a.dado
            a = a.proximo
    
            
            
    def __in__(self, val):
        a = self
        while a!=None:
            if a.dado == val:
                return True
            a = a.proximo
        return False
        
            
    def mostra_elementos(self):
        a = self
        while a!=None:
            print(a.dado)
            a = a.proximo


class Pilha():
    def __init__(self):
        self.topo = None
    
    def push(self, x):
        n = NoLL(x, self.topo)
        self.topo = n
    
    def pop(self):
        if self.topo:
            a = self.topo.dado
            self.topo = self.topo.proximo
            return a
        else:
            raise IndexError("pop em pilha vazia")
    
class Fila():
    def __init__(self):
        self.saida = None
        self.entrada = None
    
    def enqueue(self, x):
        if self.saida:
            self.entrada.proximo = NoLL(x)
            self.entrada = self.entrada.proximo
        else:   # Fila vazia
            self.entrada = NoLL(x)
            self.saida = self.entrada
    
    def dequeue(self):
        if self.saida:
            a = self.saida.dado
            self.saida = self.saida.proximo
            if not(self.saida): # Fila vazia, reseta a entrada
                self.entrada = None
            return a
        else:
            raise IndexError("dequeue em fila vazia")
    
            
            
            
    

        